/*
 Copyright(c) 2005 arton.
 
 Permission is granted for use, copying, modification, distribution,
 and distribution of modified versions of this work.
 */
using System;
using System.Collections;
using System.Diagnostics;
using System.Net;

namespace EverMore
{
	/// <summary>
	/// WebView ̊Tv̐łB
	/// </summary>
	public class WebView
	{
		Hashtable nodes;
		bool stop;
		Page page;
		int depth;

		public WebView(Uri uri, int initDepth, bool showLink)
		{
			// 
			// TODO: RXgN^ WbNɒǉĂB
			//
			depth = initDepth;
			page = new Page(depth, showLink);
			page.AddCloseEventHanlder(new EventHandler(ClosePage));
			page.Show();
			stop = false;
			nodes = new Hashtable();
			CreateNode(uri, null, 0);
		}
		public bool Stop
		{
			get
			{
				return stop;
			}
			set
			{
				stop = value;
			}
		}

		public int Depth
		{
			get
			{
				return depth;
			}
		}

		internal Node CreateNode(Uri uri, string reff, int generation)
		{
			if (stop)
			{
				return null;
			}
			bool newNode = false;
			Node n;
			lock (nodes)
			{
				n = (Node)nodes[uri.AbsoluteUri];
				if (n == null)
				{
					n = new Node(this, uri, generation);
					nodes.Add(uri.AbsoluteUri, n);
					newNode = true;
				}
			}
			if (newNode)
			{
				n.StartRead(reff);
				page.BeginInvoke(new Page.AddNodeHandler(page.AddNode), new object[] {this, n});
			}
			return n;
		}

		/// <summary>
		///  returns newly created node list, sorted by hostname orders.
		/// </summary>
		/// <param name="generation"></param>
		/// <returns>safe list for adding new node</returns>
		public IList GetNodes(int generation)
		{
			ArrayList list = new ArrayList();
			lock (nodes)
			{
				foreach (Node n in nodes.Values)
				{
					if (n.Generation == generation)
					{
						list.Add(n);
					}
				}
			}
			list.Sort();
			return list;
		}

		private void ClosePage(object sendr, EventArgs ev)
		{
			stop = true;
		}
	}
}
